# Debian Dockerfile
#
# @author Steffen Vogel <stvogel@eonerc.rwth-aachen.de>
# @copyright 2014-2020, Institute for Automation of Complex Power Systems, EONERC
# @license GNU General Public License (version 3)
#
# VILLASnode
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
###################################################################################

# You can choose between Debian and Ubuntu here
FROM debian:buster AS dev

ARG GIT_REV=unknown
ARG GIT_BRANCH=unknown
ARG VERSION=unknown
ARG DISTRO=unknown

ENV DEBIAN_FRONTEND=noninteractive

# Toolchain
RUN apt-get update && \
	apt-get install -y \
		gcc g++ \
		pkg-config cmake make \
		autoconf automake autogen libtool \
		texinfo git mercurial curl tar wget diffutils \
		flex bison \
		protobuf-compiler protobuf-c-compiler

# Dependencies
RUN apt-get update && \
	apt-get install -y \
		libssl-dev \
		libgraphviz-dev \
		libprotobuf-dev \
		libprotobuf-c-dev \
		uuid-dev \
		libconfig-dev \
		libnl-3-dev libnl-route-3-dev \
		libcurl4-openssl-dev \
		libjansson-dev \
		libzmq3-dev \
		libnanomsg-dev \
		librabbitmq-dev \
		libmosquitto-dev \
		librdkafka-dev \
		libcomedi-dev \
		libibverbs-dev \
		librdmacm-dev \
		libusb-1.0-0-dev \
		libfmt-dev \
		libspdlog-dev \
		liblua5.3-dev \
		libhiredis-dev:${ARCH}

# Add local and 64-bit locations to linker paths
ENV echo /usr/local/lib >> /etc/ld.so.conf && \
    echo /usr/local/lib64 >> /etc/ld.so.conf

ENV DISTRO=debian
ENV ARCH=x86_64
ENV TRIPLET=x86_64-linux-gnu

# or install unpackaged dependencies from source
ADD packaging/deps.sh /
RUN bash deps.sh

# Expose ports for HTTP and WebSocket frontend
EXPOSE 80
EXPOSE 443

WORKDIR /villas

FROM dev AS app

COPY . /villas/

RUN rm -rf /villas/build && mkdir /villas/build
WORKDIR /villas/build
RUN cmake .. && \
	make -j$(nproc) doc && \
	make -j$(nproc) install && \
	ldconfig

ENTRYPOINT ["villas"]

LABEL \
	org.label-schema.schema-version="1.0" \
	org.label-schema.name="VILLASnode" \
	org.label-schema.license="GPL-3.0" \
	org.label-schema.vcs-ref="$GIT_REV" \
	org.label-schema.vcs-branch="$GIT_BRANCH" \
	org.label-schema.version="$VERSION" \
	org.label-schema.vendor="Institute for Automation of Complex Power Systems, RWTH Aachen University" \
	org.label-schema.author.name="Steffen Vogel" \
	org.label-schema.author.email="stvogel@eonerc.rwth-aachen.de" \
	org.label-schema.description="A image containing all build-time dependencies for VILLASnode based on Fedora" \
	org.label-schema.url="http://fein-aachen.org/projects/villas-framework/" \
	org.label-schema.vcs-url="https://git.rwth-aachen.de/acs/public/villas/node" \
	org.label-schema.usage="https://villas.fein-aachen.org/doc/node-installation.html#node-installation-docker"
